// MfcConsoleApplication.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "MfcConsoleApplication.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "memory_leak_detect.h"

// The one and only application object

CWinApp theApp;

using namespace std;

int Sum(int n)
{

	if (n > 7) throw range_error("Sum(n), n < 8");

	return n * (n + 1) / 2;
}

int StartMain()
{
	
	FILE* pFile;

	errno_t file_not_open = fopen_s(&pFile, "HelloCpp.txt", "w");
	
	// Use C++ library rather than C library

	// file open/creation successful
	if (!file_not_open)
	{
		try
		{
			//1. std::unique_ptr<FILE, int(*)(FILE*)> upFile(pFile, fclose);

			struct FileCloser
			{
				void operator()(FILE *fptr)
				{
					cout << "Closing file.\n";
					fclose(fptr);
				}
			};

			//2. std::unique_ptr<FILE, FileCloser> upFile(pFile);

			std::unique_ptr<FILE, void(*)(FILE*)> upFile(pFile, [](FILE* fptr)->void 
				{
					cout << "File Closing in Lambda!!\n";
					fclose(fptr);
				});

			for (int i = 0; i < 10; ++i)
			{
				fprintf_s(pFile, "I love it: %d\n", Sum(i));
			}
		}
		catch (...) { }
	}
	
	cin.get();

	return 0;
}

int main()
{
    int nRetCode = 0;

    HMODULE hModule = ::GetModuleHandle(nullptr);

    if (hModule != nullptr)
    {
        // initialize MFC and print and error on failure
        if (!AfxWinInit(hModule, nullptr, ::GetCommandLine(), 0))
        {
            // TODO: change error code to suit your needs
            wprintf(L"Fatal Error: MFC initialization failed\n");
            nRetCode = 1;
        }
        else
        {
            // TODO: code your application's behavior here.
			return StartMain();
        }
    }
    else
    {
        // TODO: change error code to suit your needs
        wprintf(L"Fatal Error: GetModuleHandle failed\n");
        nRetCode = 1;
    }

    return nRetCode;
}
