// This MFC Samples source code demonstrates using MFC Microsoft Office Fluent User Interface 
// (the "Fluent UI") and is provided only as referential material to supplement the 
// Microsoft Foundation Classes Reference and related electronic documentation 
// included with the MFC C++ library software.  
// License terms to copy, use or distribute the Fluent UI are available separately.  
// To learn more about our Fluent UI licensing program, please visit 
// http://go.microsoft.com/fwlink/?LinkId=238214.
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// WinMFCApplicationView.cpp : implementation of the CWinMFCApplicationView class
//

#include "stdafx.h"
// SHARED_HANDLERS can be defined in an ATL project implementing preview, thumbnail
// and search filter handlers and allows sharing of document code with that project.
#ifndef SHARED_HANDLERS
#include "WinMFCApplication.h"
#endif

#include "WinMFCApplicationDoc.h"
#include "WinMFCApplicationView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "memory_leak_detect.h"

// CWinMFCApplicationView

IMPLEMENT_DYNCREATE(CWinMFCApplicationView, CView)

BEGIN_MESSAGE_MAP(CWinMFCApplicationView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CWinMFCApplicationView::OnFilePrintPreview)
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_EDIT_POSTSTRING, &CWinMFCApplicationView::OnEditPoststring)
END_MESSAGE_MAP()

// CWinMFCApplicationView construction/destruction

CWinMFCApplicationView::CWinMFCApplicationView()
{
	// TODO: add construction code here

}

CWinMFCApplicationView::~CWinMFCApplicationView()
{
}

BOOL CWinMFCApplicationView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CWinMFCApplicationView drawing

void CWinMFCApplicationView::OnDraw(CDC* /*pDC*/)
{
	CWinMFCApplicationDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CWinMFCApplicationView printing


void CWinMFCApplicationView::OnFilePrintPreview()
{
#ifndef SHARED_HANDLERS
	AFXPrintPreview(this);
#endif
}

BOOL CWinMFCApplicationView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CWinMFCApplicationView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CWinMFCApplicationView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CWinMFCApplicationView::OnRButtonUp(UINT /* nFlags */, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CWinMFCApplicationView::OnContextMenu(CWnd* /* pWnd */, CPoint point)
{
#ifndef SHARED_HANDLERS
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
#endif
}


// CWinMFCApplicationView diagnostics

#ifdef _DEBUG
void CWinMFCApplicationView::AssertValid() const
{
	CView::AssertValid();
}

void CWinMFCApplicationView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CWinMFCApplicationDoc* CWinMFCApplicationView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWinMFCApplicationDoc)));
	return (CWinMFCApplicationDoc*)m_pDocument;
}
#endif //_DEBUG


// CWinMFCApplicationView message handlers


void CWinMFCApplicationView::OnEditPoststring()
{
	// TODO: Add your command handler code here

	// Never use RAW pointers in C++

	//CString *pStr = 
		//new CString(L"It is a very dangerous practice!");

	MemLeakCheck(OnEditPosting);

	std::unique_ptr<CString> uptr(new CString(L"This is a bit better, but not perfect!!!"));


	/*
	
	Some serious work here

	*/

	// PostMessage() returns immediately before the sent message is possibly processed
	// SendMessage() returns after when the sent message is processed.
	AfxGetMainWnd()->PostMessageW(WM_POST_STR, (WPARAM)uptr.release());
}
